// SilberLand MUDlib
//
// LIVING/DESCRIPTION.C -- description for living objects
//
// $Date: 1997/09/25 15:07:51 $
/* $Revision: 2.2 $
 * $Log: description.c,v $
 * Revision 2.2  1997/09/25 15:07:51  Woody
 * _query_material()
 *
 * Revision 2.1  1997/06/25 11:53:32  Woody
 * unnoetiges short() entfernt, neu: is_class_member()
 *
 * Revision 2.0  1997/03/13 00:54:07  Woody
 * prepared for revision control
 *
 * Revision 1.1  96/05/25  18:00:00  Woody
 * short() Aenderungen wieder retour
 *
 * Revision 1.0  96/02/22  23:00:00  Hadra
 * short() geaendert
 */                            

#include "/std/sys_debug.h"

inherit "/std/container/description";

#pragma strong_types

#define NEED_PROTOTYPES

#include <thing/properties.h>
#include <properties.h>
#include <language.h>
#include <defines.h>
#include <class.h>

void create()
{
  ::create();
  Set(P_GENDER, SAVE, F_MODE);
}

varargs string long() {
  string str, cap_pronoun;
  string descr, invl;
  int hpnt, max_hpnt;
  mixed filter;

  descr = "";
  cap_pronoun = capitalize(QueryPronoun());
  str = funcall(QueryProp(P_LONG));
  if(!stringp(str)) str = "";
  hpnt = QueryProp( P_HP );
  max_hpnt = QueryProp( P_MAX_HP );
  if (hpnt < max_hpnt/10) 
    descr += cap_pronoun + " steht auf der Schwelle des Todes.\n";
  else if (hpnt < max_hpnt/5) 
    descr += cap_pronoun + " braucht dringend einen Arzt.\n";
  else if (hpnt < max_hpnt*3/10) 
    descr += cap_pronoun + " ist in keiner guten Verfassung.\n";
  else if (hpnt < max_hpnt*4/10) 
    descr += cap_pronoun + " wankt bereits bedenklich.\n";
  else if (hpnt < max_hpnt/2) 
    descr += cap_pronoun + " macht einen mitgenommenen Eindruck.\n";
  else if (hpnt < max_hpnt*6/10) 
    descr += cap_pronoun + " sieht nicht mehr taufrisch aus.\n";
  else if (hpnt < max_hpnt*7/10) 
    descr += cap_pronoun + " ist leicht angeschlagen.\n";
  else if (hpnt < max_hpnt*8/10) 
    descr += cap_pronoun + " fuehlte sich heute schon besser.\n";
  else if (hpnt < max_hpnt*9/10) 
    descr += cap_pronoun + " ist schon etwas geschwaecht.\n";
  else
    descr += cap_pronoun + " ist absolut fit.\n";
  str += descr;
  if(filter = QueryProp(P_TRANSPARENT))
  {
    invl = make_invlist(PL, all_inventory(ME),
      this_player()->QueryProp(P_SHORTINV) ? 0 : 2);
    if(invl != "")
      str += capitalize(QueryPronoun())+" traegt bei sich:\n" + invl;
  }
  return str;
}

#define DD(x) tell_object(find_player("debugger"), (x))

string name(int casus, int demonst)
{
  string s;
  
// DD(sprintf("name: me = %O, prev = %O\n", this_object(), previous_object()));
  
  if( QueryProp( P_INVIS ) )
  {
    if( casus == RAW ) return "Jemand";
    return ({"Jemand","Jemands","Jemandem","Jemanden"})[casus];
  }
  if (QueryProp(P_FROG) && casus != RAW )
  {
    SetProp(P_ARTICLE,1);
    s=QueryArticle(casus,0)+"Frosch";
    if (casus==WESSEN) s += "es";
    SetProp(P_ARTICLE,0);
    return s;
  }
  return ::name( casus, demonst );
}

static int _query_gender()
{
  if (QueryProp(P_FROG)) return MALE;
  return Query(P_GENDER);
}

static mixed _set_name(mixed nm )
{
  string lvnam;
  lvnam = nm;
  if(pointerp(nm)) lvnam = nm[0];
  set_living_name(lower_case(lvnam));
  return Set(P_NAME, nm);
}

int _query_container()
{
  return 0;
}

int is_class_member(mixed str) {
  if (::is_class_member(str))
    return 1;

  if (stringp(str))
    str = ({str});

  if (!pointerp(str))
    return 0;

  if ((member(str, CL_UNDEAD) >= 0) &&
      ::is_class_member( ({CL_ZOMBIE, CL_SKELETON}) ))
    return 1;
  else if ((member(str, CL_GOBLIN) >= 0) &&
           ::is_class_member( ({ CL_HOBGOBLIN }) ))
    return 1;
  else
    return 0;
}

mapping _query_material() {
  mixed res;

  if (mappingp(res=Query(P_MATERIAL)))
    return res;
  return ([MAT_MISC_LIVING:100]);
}
