/*
 * SilberLand Mudlib
 * ---
 * player/potion.c - potion handling for player
 * uebernommen aus der MorgenGrauen Mudlib
 * ---
 * $Date: 1997/03/13 01:43:06 $
 * $Revision: 3.4 $
 * $Log: potion.c,v $
 * Revision 3.4  1997/03/13 01:43:06  Woody
 * prepared for revision control
 *
 * Revision 3.3  1996/11/03  Woody
 * *ARGL* Auch Heiltraenke muessen natuerlich aus der Liste entfernt werden!
 *
 * Revision 3.2  1996/10/18  Woody
 * 3.1 hatte nen Bug :), wenn sich das Objekt nach ZT-Findung selbst removed
 *
 * Revision 3.1  1996/10/05  Woody
 * ZT-Finden sicherer gegen disconnect bei der Attributauswahl gemacht
 *
 * Revision 3.0  1996/10/01  Woody
 * Etliches Debugging, neues Attributsystem, Verwenden von *RealAttribute()
 * P_VISITED_POTIONROOMS, P_BONUS_POTIONS, ME's raus
 *
 * Revision 2.7  1994/09/13  16:36:24  Rochus
 * *** empty log message ***
 *
 * Revision 2.7  1994/09/13  16:36:24  Rochus
 * *** empty log message ***
 *
 * Revision 2.7  1994/09/13  11:47:28  Rochus
 * An Attribute-Offsets angepasst.
 *
 * Revision 2.6  1994/07/14  15:15:51  Jof
 * Removed command mappings
 *
 * Revision 2.5  1994/06/13  07:36:24  Jof
 * Removed SET_METHODs
 *
 * Revision 2.4  1994/03/23  15:05:41  Boing
 * automatisches Abspeichern nach erhoehen eines Attributs
 * (Das WAR schon mal drin!!!! *curse*)
 *
 * Revision 2.3  1994/03/17  23:36:55  Jof
 * PROTECTED -> SECURED & Reindented
 *
 * Revision 2.2  1994/02/24  13:03:14  Jof
 * Private removed
 *
 * Revision 2.1  1994/01/17  23:35:05  mud
 * *** empty log message ***
 *
 * Revision 2.0  1994/01/13  16:59:27  mud
 * *** empty log message ***
 *
 * Revision 1.3  1994/01/08  13:12:20  mud
 * *** empty log message ***
 *
 * Revision 1.2  1994/01/05  16:17:07  mud
 * changed save variables partly to mapping entry
 *             
 */                            

#pragma strong_types

#define NEED_PROTOTYPES

#include "/sys/thing/properties.h"
#include "/sys/player/potion.h"

#include <properties.h>
#include <attributes.h>
#include <defines.h>
#include <wizlevels.h>
#include <player/base.h>
#include <living/life.h>

#define POTIONMASTER "secure/potionmaster"

static mixed current;
static mixed *list;

mixed *potionrooms;

static mixed _query_potionrooms();

void create()
{
  if (!potionrooms) potionrooms=POTIONMASTER->InitialList();

  // Spieler, die noch alte Potionrooms gesetzt haben, bekommen
  // alle ueber 10 wieder abgezogen und muessen nun uU. auch
  // auf FP-Suche gehen...
  if (sizeof(potionrooms) > 10) potionrooms = potionrooms[0..9];

  Set(P_POTIONROOMS, -1, F_SET_METHOD);         // no tampering by methods
  Set(P_POTIONROOMS, SECURED, F_MODE_AS);       // no tampering with list
  if (!stringp(Query(P_VISITED_POTIONROOMS)))
    Set(P_VISITED_POTIONROOMS, " ");
  Set(P_VISITED_POTIONROOMS, SAVE|PROTECTED, F_MODE_AS);
  Set(P_BONUS_POTIONS, SAVE|PROTECTED, F_MODE_AS);
  current=0;
}

varargs static int ReportPotion(string s);
static int SelectWhich();
static int ask_question();
static int get_answer(string erg);
static int raise(string what);

varargs int FindPotion(string s)
{
  int flag, pnum;
  string str;

  flag=1;
  current=previous_object();
  if (QueryProp(P_TRANK_FINDEN) && IS_WIZARD(this_object()))
    return ReportPotion(s);
  if (QueryProp(P_KILLS)) return 0;
  if (QueryProp(P_BONUS_POTIONS) >
      (pnum=count_bits(str=QueryProp(P_VISITED_POTIONROOMS))))
    SetProp(P_BONUS_POTIONS, pnum);

  if (!potionrooms || potionrooms==({}) ||
      !(POTIONMASTER->InList(current, potionrooms)))
    flag=0;
  if ((pnum=POTIONMASTER->HasPotion(current))<0)
    return 0;

  if (!test_bit(str,pnum))
  {
    SetProp(P_VISITED_POTIONROOMS, set_bit(str,pnum));
    if (!flag)
      SetProp(P_BONUS_POTIONS, QueryProp(P_BONUS_POTIONS)+1);
  }
  if (!flag) return 0;
  if (query_input_pending(this_object()) || query_editing(this_object()))
  {
    write("Jetzt haettest Du fast einen Zaubertrank gefunden. Du solltest den\n"
          "Editor/das More verlassen und es dann noch einmal versuchen!\n");
    return 1;
  }

  current=file_name(current);
  log_file("POTIONS", dtime(time()) + "  " +capitalize(getuid()) + " in " + 
       current + "\n");
  current=explode(current, "#")[0];
  // potionrooms=POTIONMASTER->RemoveList(previous_object(), potionrooms);
  return ReportPotion(s);
}

varargs static int ReportPotion(string s)
{
  if (s) write(s);
  else write("Du findest einen Zaubertrank, den Du sofort trinkst.\n");
  SelectWhich();
  return 1;
}

static int SelectWhich()
{
  int x,sum;
  list=({"Intelligenz","Kraft","Geschicklichkeit","Ausdauer"});
  if ((sum=ME->QueryRealAttribute(A_INT))>=A_MAX) list-=({"Intelligenz"});
  if ((x=ME->QueryRealAttribute(A_STR))>=A_MAX) list-=({"Kraft"});
  sum+=x;
  if ((x=ME->QueryRealAttribute(A_DEX))>=A_MAX) list-=({"Geschicklichkeit"});
  sum+=x;
  if ((x=ME->QueryRealAttribute(A_CON))>=A_MAX) list-=({"Ausdauer"});
  sum+=x;
  if ((sum>=A_SUM) || (!sizeof(list))) {
    ME->heal_self(10000000);
    write("Der Trank hat Dich geheilt.\n");
    potionrooms=
      POTIONMASTER->RemoveList(current, potionrooms);
    save_me(1);
    return 1;
  }
  if (sizeof(list)==1) return raise(list[0]);
  ask_question();
  return 1;
}

static int ask_question()
{
  int i;

  write("Deine Attribute sehen so aus:\n\n");
  printf("Intelligenz     : %2d (%+d)\n",
         QueryRealAttribute(A_INT),QueryAttributeOffset(A_INT));
  printf("Kraft           : %2d (%+d)\n",
         QueryRealAttribute(A_STR),QueryAttributeOffset(A_STR));
  printf("Geschicklichkeit: %2d (%+d)\n",
         QueryRealAttribute(A_DEX),QueryAttributeOffset(A_DEX));
  printf("Ausdauer        : %2d (%+d)\n",
         QueryRealAttribute(A_CON),QueryAttributeOffset(A_CON));
  write("\nWas moechtest Du erhoehen ? Du hast folgende Moeglichkeiten:\n");
  for (i=0;i<sizeof(list);i++)
    printf("%d) %s\n", i+1,list[i]);
  printf("\nBitte gib jetzt eine Zahl (1-%d) an: ", i);
  input_to("get_answer");
  return 1;
}

static int get_answer(string erg)
{
  int num;

  if (erg && stringp(erg))
  {
    if (sscanf(erg,"%d",num)<1) num=0;
    if (num>0 && num<=sizeof(list))
      return raise(list[num-1]);
  }
  write("Deine Wahl war ungueltig. Bitte versuchs nochmal !\n\n");
  return ask_question();
}

static int raise(string what) {
  string attr;
  int yet;

  switch (what) {
  case "Geschicklichkeit":
    attr=A_DEX; break;
  case "Intelligenz":
    attr=A_INT; break;
  case "Kraft":
    attr=A_STR; break;
  case "Ausdauer":
    attr=A_CON; break;
  default: return 0;
  }

  yet=QueryRealAttribute(attr);
  SetRealAttribute(attr,yet+1);
  printf("Deine %s hat sich von %d auf %d erhoeht.\n", what, yet, yet+1);
  potionrooms=
    POTIONMASTER->RemoveList(current, potionrooms);
  save_me(1);
  return 1;
}

static mixed _query_potionrooms()
{
  return Set(P_POTIONROOMS, potionrooms);
}
